#ifndef _H_CFE3CD27726D329938655E0F9049B845_SignalArray_DCPS_H_
#define _H_CFE3CD27726D329938655E0F9049B845_SignalArray_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SignalArray_.h"


namespace lgsvl_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SignalArray_TypeSupportInterface;

            typedef SignalArray_TypeSupportInterface * SignalArray_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SignalArray_TypeSupportInterface> SignalArray_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SignalArray_TypeSupportInterface> SignalArray_TypeSupportInterface_out;


            class SignalArray_DataWriter;

            typedef SignalArray_DataWriter * SignalArray_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SignalArray_DataWriter> SignalArray_DataWriter_var;
            typedef DDS_DCPSInterface_out < SignalArray_DataWriter> SignalArray_DataWriter_out;


            class SignalArray_DataReader;

            typedef SignalArray_DataReader * SignalArray_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SignalArray_DataReader> SignalArray_DataReader_var;
            typedef DDS_DCPSInterface_out < SignalArray_DataReader> SignalArray_DataReader_out;


            class SignalArray_DataReaderView;

            typedef SignalArray_DataReaderView * SignalArray_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SignalArray_DataReaderView> SignalArray_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SignalArray_DataReaderView> SignalArray_DataReaderView_out;

            struct SignalArray_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SignalArray_, struct SignalArray_Seq_uniq_> SignalArray_Seq;
            typedef DDS_DCPSSequence_var < SignalArray_Seq> SignalArray_Seq_var;
            typedef DDS_DCPSSequence_out < SignalArray_Seq> SignalArray_Seq_out;

            class  SignalArray_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SignalArray_TypeSupportInterface_ptr _ptr_type;
                typedef SignalArray_TypeSupportInterface_var _var_type;

                static SignalArray_TypeSupportInterface_ptr _duplicate (SignalArray_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SignalArray_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SignalArray_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SignalArray_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SignalArray_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SignalArray_TypeSupportInterface () {};
                ~SignalArray_TypeSupportInterface () {};
            private:
                SignalArray_TypeSupportInterface (const SignalArray_TypeSupportInterface &);
                SignalArray_TypeSupportInterface & operator = (const SignalArray_TypeSupportInterface &);
            };

            class  SignalArray_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SignalArray_DataWriter_ptr _ptr_type;
                typedef SignalArray_DataWriter_var _var_type;

                static SignalArray_DataWriter_ptr _duplicate (SignalArray_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SignalArray_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SignalArray_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SignalArray_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SignalArray_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SignalArray_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SignalArray_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SignalArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SignalArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SignalArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SignalArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SignalArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SignalArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SignalArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SignalArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SignalArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SignalArray_& instance_data) = 0;

            protected:
                SignalArray_DataWriter () {};
                ~SignalArray_DataWriter () {};
            private:
                SignalArray_DataWriter (const SignalArray_DataWriter &);
                SignalArray_DataWriter & operator = (const SignalArray_DataWriter &);
            };

            class  SignalArray_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SignalArray_DataReader_ptr _ptr_type;
                typedef SignalArray_DataReader_var _var_type;

                static SignalArray_DataReader_ptr _duplicate (SignalArray_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SignalArray_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SignalArray_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SignalArray_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SignalArray_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SignalArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SignalArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SignalArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SignalArray_& instance) = 0;

            protected:
                SignalArray_DataReader () {};
                ~SignalArray_DataReader () {};
            private:
                SignalArray_DataReader (const SignalArray_DataReader &);
                SignalArray_DataReader & operator = (const SignalArray_DataReader &);
            };

            class  SignalArray_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SignalArray_DataReaderView_ptr _ptr_type;
                typedef SignalArray_DataReaderView_var _var_type;

                static SignalArray_DataReaderView_ptr _duplicate (SignalArray_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SignalArray_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SignalArray_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SignalArray_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SignalArray_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SignalArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SignalArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SignalArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SignalArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SignalArray_& instance) = 0;

            protected:
                SignalArray_DataReaderView () {};
                ~SignalArray_DataReaderView () {};
            private:
                SignalArray_DataReaderView (const SignalArray_DataReaderView &);
                SignalArray_DataReaderView & operator = (const SignalArray_DataReaderView &);
            };
        }

    }

}

#endif
