#ifndef _H_F9EB354F002DE7639CEDC24D76BB64A8_Signal_DCPS_H_
#define _H_F9EB354F002DE7639CEDC24D76BB64A8_Signal_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Signal_.h"


namespace lgsvl_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Signal_TypeSupportInterface;

            typedef Signal_TypeSupportInterface * Signal_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Signal_TypeSupportInterface> Signal_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Signal_TypeSupportInterface> Signal_TypeSupportInterface_out;


            class Signal_DataWriter;

            typedef Signal_DataWriter * Signal_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Signal_DataWriter> Signal_DataWriter_var;
            typedef DDS_DCPSInterface_out < Signal_DataWriter> Signal_DataWriter_out;


            class Signal_DataReader;

            typedef Signal_DataReader * Signal_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Signal_DataReader> Signal_DataReader_var;
            typedef DDS_DCPSInterface_out < Signal_DataReader> Signal_DataReader_out;


            class Signal_DataReaderView;

            typedef Signal_DataReaderView * Signal_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Signal_DataReaderView> Signal_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Signal_DataReaderView> Signal_DataReaderView_out;

            struct Signal_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Signal_, struct Signal_Seq_uniq_> Signal_Seq;
            typedef DDS_DCPSSequence_var < Signal_Seq> Signal_Seq_var;
            typedef DDS_DCPSSequence_out < Signal_Seq> Signal_Seq_out;

            class  Signal_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Signal_TypeSupportInterface_ptr _ptr_type;
                typedef Signal_TypeSupportInterface_var _var_type;

                static Signal_TypeSupportInterface_ptr _duplicate (Signal_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Signal_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Signal_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Signal_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Signal_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Signal_TypeSupportInterface () {};
                ~Signal_TypeSupportInterface () {};
            private:
                Signal_TypeSupportInterface (const Signal_TypeSupportInterface &);
                Signal_TypeSupportInterface & operator = (const Signal_TypeSupportInterface &);
            };

            class  Signal_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Signal_DataWriter_ptr _ptr_type;
                typedef Signal_DataWriter_var _var_type;

                static Signal_DataWriter_ptr _duplicate (Signal_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Signal_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Signal_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Signal_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Signal_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Signal_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Signal_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Signal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Signal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Signal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Signal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Signal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Signal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Signal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Signal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Signal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Signal_& instance_data) = 0;

            protected:
                Signal_DataWriter () {};
                ~Signal_DataWriter () {};
            private:
                Signal_DataWriter (const Signal_DataWriter &);
                Signal_DataWriter & operator = (const Signal_DataWriter &);
            };

            class  Signal_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Signal_DataReader_ptr _ptr_type;
                typedef Signal_DataReader_var _var_type;

                static Signal_DataReader_ptr _duplicate (Signal_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Signal_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Signal_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Signal_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Signal_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Signal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Signal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Signal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Signal_& instance) = 0;

            protected:
                Signal_DataReader () {};
                ~Signal_DataReader () {};
            private:
                Signal_DataReader (const Signal_DataReader &);
                Signal_DataReader & operator = (const Signal_DataReader &);
            };

            class  Signal_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Signal_DataReaderView_ptr _ptr_type;
                typedef Signal_DataReaderView_var _var_type;

                static Signal_DataReaderView_ptr _duplicate (Signal_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Signal_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Signal_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Signal_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Signal_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Signal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Signal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Signal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Signal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Signal_& instance) = 0;

            protected:
                Signal_DataReaderView () {};
                ~Signal_DataReaderView () {};
            private:
                Signal_DataReaderView (const Signal_DataReaderView &);
                Signal_DataReaderView & operator = (const Signal_DataReaderView &);
            };
        }

    }

}

#endif
